      subroutine TestAtomString(StAtoms,KeyWild,KeyAtMol,KeyMol,KeySym,
     1                          KeyAtMolMix,ErrString)
      use Atoms_mod
      include 'fepc.cmn'
      include 'basic.cmn'
      dimension xp(3)
      character*(*) StAtoms,ErrString
      character*80  p80
      ErrString=' '
      NAtPom=0
      NMolPom=0
      if(StAtoms.eq.' ') go to 9000
      k=1
500   if(StAtoms(k:k).eq.' ') then
        k=k+1
        go to 500
      endif
      StAtoms=StAtoms(k:)
      k=0
1000  kp=k+1
      call kus(StAtoms,k,p80)
      call Uprat(p80)
      kk=idel(p80)
      StAtoms(kp:kp+kk-1)=p80(1:kk)
      if(KeyWild.eq.0.and.(index(p80,'*').ne.0.or.index(p80,'?').ne.0))
     1    then
        ErrString='"'//p80(1:idel(p80))//
     1            '" wild character not applicable.'
        go to 9999
      endif
      if(KeySym.eq.0.and.KeyMol.eq.0.and.index(p80,'#').ne.0)
     1    then
        ErrString='"'//p80(1:idel(p80))//
     1            '" atom generated by symmetry not applicable.'
        go to 9999
      endif
      if(KeySym.eq.0.or.index(p80,'#').le.0) then
        i=0
        if(KeyAtMol.eq.1) then
          n=NAtCalc
        else
          n=NAtInd
        endif
1100    j=ktatmv(p80,n,1-KeyMol)
        if(j.eq.0) then
          if(i.eq.0) then
            ErrString='The string "'//p80(1:idel(p80))//
     1                '" doesn''t define any atom.'
            go to 9999
          endif
        else
          if(j.gt.0.and.j.le.n.or.j.ge.NAtMolFr(1,1)) then
            i=i+1
            NAtPom=NAtPom+1
          else if(j.lt.0) then
            i=i+1
            NMolPom=NMolPom+1
          endif
          go to 1100
        endif
      else
        if(KeyAtMol.eq.1) then
          n=NAtInd
          NAtInd=NAtCalc
        endif
        call CtiAt(p80,xp,ich)
        if(KeyAtMol.eq.1) NAtInd=n
        if(ich.ne.-1) then
          if(ich.eq.0) then
            ErrString='The string" '//p80(1:idel(p80))//
     1                '" cannot be an atom name.'
          else if(ich.eq.-2) then
            ErrString='Jiz oznameno'
            go to 9999
          endif
        endif
      endif
      if(k.lt.len(StAtoms)) go to 1000
      if(NAtPom.gt.0.and.NMolPom.gt.0) then
        if(KeyAtMolMix.eq.0) then
          ErrString='The command mixes atoms and molecules.'
          ich=1
        else
          ErrString='Mixed'
        endif
        go to 9999
      endif
9000  ich=0
9999  return
      end
